using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Marblecore;

namespace MarblecoreImagingExample
{
    public partial class MarblecoreImagingExamplePage : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

        }

        /**
         * This example loads an image from a file, does some processing and writes embedded images using base64 encoding to the page.
         */
        public string EmbedExampleImages()
        {
            MarblecoreImaging pImaging = new MarblecoreImaging();

            string sEmbedImages = "";
            string sImage = Server.MapPath("MarblecoreImagingExample.jpg");
            long nStart = System.Environment.TickCount;

            // Have a license? Uncomment the following line and supply your product key and license code...
            //pImaging.LicenseVerify("<Product key>", "<License code>");

            if (pImaging.LoadFromFile(sImage))
            {
                // Embed the original image
                sEmbedImages += "<div>&nbsp;</div><div><b>Original image (inserted using base64 embedding):</b> <i>Time consumed " + (System.Environment.TickCount - nStart) + "ms</i></div><div><img src=\"data:" + pImaging.MIME + ";base64," + pImaging.SaveToBase64() + "\" alt=\"Base64 encoded image\" width=\"" + pImaging.Width + "\" height=\"" + pImaging.Height + "\" /></div>";
                nStart = System.Environment.TickCount;

                // Create a thumbnail and embed the result image
                pImaging.Thumbnail(200, 200, MarblecoreImagingThumbnail.MarblecoreImagingThumbnailSkew3D);

                sEmbedImages += "<div>&nbsp;</div><div><b>Thumbnail with effect:</b> <i>Time consumed " + (System.Environment.TickCount - nStart) + "ms</i></div><div><img src=\"data:" + pImaging.MIME + ";base64," + pImaging.SaveToBase64() + "\" alt=\"Base64 encoded image\" width=\"" + pImaging.Width + "\" height=\"" + pImaging.Height + "\" /></div>";
                nStart = System.Environment.TickCount;

                // Reload the original image, apply the Oilpaint filter and embed the result image
                pImaging.LoadFromFile(pImaging.FilePath);
                pImaging.FilterOilPaint();

                sEmbedImages += "<div>&nbsp;</div><div><b>Oilpaint filter:</b> <i>Time consumed " + (System.Environment.TickCount - nStart) + "ms</i></div><div><img src=\"data:" + pImaging.MIME + ";base64," + pImaging.SaveToBase64() + "\" alt=\"Base64 encoded image\" width=\"" + pImaging.Width + "\" height=\"" + pImaging.Height + "\" /></div>";
            }
            else sEmbedImages = "<div>&nbsp;</div><b>Image (" + sImage + ") not found!</b>";

            return sEmbedImages;
        }
    }
}
